/* ---------------------------------------------------------- */
/*  pako_sdl_opengl_app.cpp                                   */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief    Pako SDL Game Library - OpenGL application class
    @author   rerofumi
    @since    Nov.05.2006
*/
/*-----------------------------------------------------
 Copyright (C) 2006 fumi2kick/rerofumi <rero2@yuumu.org>
 All Rights Reserved.
 ------------------------------------------------------*/

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include "pako_psp_opengl_app.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/*-------------------------------*/
/* global value                  */
/*-------------------------------*/

static EGLint attrib_list [] = {
	EGL_RED_SIZE, 4,	/* 0 */
	EGL_GREEN_SIZE, 4,	/* 2 */
	EGL_BLUE_SIZE, 4,	/* 4 */
	EGL_ALPHA_SIZE, 1,	/* 6 */
	EGL_STENCIL_SIZE, 0,	/* 8 */
	EGL_DEPTH_SIZE, 16,	/* 10 */
	EGL_NONE
};

/*-------------------------------*/
/* local routine                 */
/*-------------------------------*/

/*-------------------------------*/
/* implementatiion               */
/*-------------------------------*/

/*------------------------------------------------------*/
/* constructor/destructor                               */
/*------------------------------------------------------*/

/**
 * RXgN^
 */
PakoPSPOpenglApp::PakoPSPOpenglApp()
{
  width = 480;
  height = 272;
}

/**
 * fXgN^(n)
 */
PakoPSPOpenglApp::~PakoPSPOpenglApp()
{
}


/*------------------------------------------------------*/
/* interface                                            */
/*------------------------------------------------------*/

/*------------------------------------------------------*/
/* protected method                                     */
/*------------------------------------------------------*/

/* ----------------------------------------- */
/* --- onBoot() */
/**
 * PSPGL pʐݒ̏ۂɍs
 *
 * @return 0ŒʏIAȊOŃG[vʒm
 *
 */
int PakoPSPOpenglApp::onBoot(void)
{
  EGLConfig config;
  EGLint num_configs;
  int  r;

  /* --- super */
  r = PakoSimpleApp::onBoot();
  if (r != 0) {
    return(1);
  }

  /* --- egl initialize */
  dpy = eglGetDisplay(0);
  eglInitialize(dpy, NULL, NULL);

  eglChooseConfig(dpy, attrib_list, &config, 1, &num_configs);
  if (num_configs == 0) {
    return(1);
  }

  eglGetConfigAttrib(dpy, config, EGL_WIDTH, &width);
  eglGetConfigAttrib(dpy, config, EGL_HEIGHT, &height);

  ctx = eglCreateContext(dpy, config, NULL, NULL);
  surface = eglCreateWindowSurface(dpy, config, 0, NULL);
  eglMakeCurrent(dpy, surface, surface, ctx);

  return(0);
}


/* ----------------------------------------- */
/* --- onShutdown() */
/**
 * execute ̏IĂяo㏈\bh
 * VXe̔j
 *
 * @return 0ŒʏIAȊOŃG[vʒm
 *
 */
int PakoPSPOpenglApp::onShutdown(void)
{
  /* --- pspgl end */
  eglTerminate(dpy);

  return(0);
}


/* ----------------------------------------- */
/* --- swapFrameBuffer() */
/**
 * t[̍ŌŌĂяo郁\bh
 * tickDisplay()̒ɌĂ΂AۂɃt[obt@
 * ʂɕ\铮s
 * p̃foCXɉĎ
 *
 */
void PakoPSPOpenglApp::swapFrameBuffer(void)
{
  eglSwapBuffers(dpy, surface);
}

/*------------------------------------------------------*/
/* local method                                         */
/*------------------------------------------------------*/
