/* ---------------------------------------------------------- */
/*  pako_simple_app.h                                         */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief    Pako SDL Game Library - Foundation application class
    @author   rerofumi
    @since    Nov.04.2006
*/
/*-----------------------------------------------------
 Copyright (C) 2006 fumi2kick/rerofumi <rero2@yuumu.org>
 All Rights Reserved.
 ------------------------------------------------------*/

#ifndef PAKO_SIMPLE_APP_H
#define PAKO_SIMPLE_APP_H

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include "SDL.h"
#include "SDL_main.h"
#include "SDL_Audio.h"
#include "SDL_mixer.h"

#include "input.h"
#include "sound.h"


/*-------------------------------*/
/* define                        */
/*-------------------------------*/

//! t[XLbv
#define  PAKO_FRAME_SKIP_NONE  0
//! t[XLbvL
#define  PAKO_FRAME_SKIP_DISPLAY  1

//! ftHgʃTCYA
#define  PAKO_FRAME_SIZE_W  480
//! ftHgʃTCYAc
#define  PAKO_FRAME_SIZE_H  272

//! ftHgt[[g
#define  PAKO_FRAME_RATE  60

/*-------------------------------*/
/* struct                        */
/*-------------------------------*/

/*-------------------------------*/
/* class                         */
/*-------------------------------*/

/**
 * @brief Q[AvP[V{NX
 *        SDLx[X̃Q[AvP[VǗs
 *        Q[{̂̌pNX
 *
 * @todo -
 * @bug -
 */
class PakoSimpleApp
{
  /* ----------------------------------- */
  /* --- RXgN^EfXgN^ */
 public:
  PakoSimpleApp();
  virtual  ~PakoSimpleApp();

  /* ----------------------------------- */
  /* --- pubNo */
 public:
  //! ^[Qbg@
  int m_TargetMachine;
  //! \TCY
  int m_WindowSizeW;
  //! \TCYc
  int m_WindowSizeH;
  //! t[[gݒ
  int m_FrameRate;
  //! t[XLbv[h
  int m_FrameSkipMode;
  //! t[XLbv
  int m_SkipRate;
  //! Ñt[JE^
  int m_AppCounter;

  /* ----------------------------------- */
  /* --- thNXo */
 protected:
  //! t[^C~O
  int  m_SystemTime;
  //! Ot[̎
  int  m_BeforeTiming;

  /* ----------------------------------- */
  /* --- vCx[go */
 private:

  /* ----------------------------------- */
  /* --- pubN\bh */
 public:
  int execute(void);
  void setFrameRate(int fps);
  void setFrameSkipMode(int mode);

  /* ----------------------------------- */
  /* --- thNX\bh */
 protected:
  virtual int onBoot(void);
  virtual int onShutdown(void);
  virtual int onExecuteBefore(void);
  virtual int onExecuteAfter(void);
  virtual bool tick(void);
  virtual bool tickDisplay(void);
  virtual void swapFrameBuffer(void);

  /* ----------------------------------- */
  /* --- vCx[g\bh */
 private:

};


#endif

