/* ---------------------------------------------------------- */
/*  tcgs_cave_2d.cpp                                          */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief    cave retro version - game main
    @author   rerofumi
    @since    Nov.10.2006
*/
/*-----------------------------------------------------
 Copyright (C) 2006 fumi2kick/rerofumi <rero2@yuumu.org>
 All Rights Reserved.
 ------------------------------------------------------*/

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include "pako_math.h"
#include "tcgs_cave_2d.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

/*-------------------------------*/
/* global value                  */
/*-------------------------------*/

/*-------------------------------*/
/* local routine                 */
/*-------------------------------*/

/*-------------------------------*/
/* implementatiion               */
/*-------------------------------*/

/*------------------------------------------------------*/
/* constructor/destructor                               */
/*------------------------------------------------------*/

/**
 * RXgN^
 */
Cave2dGame::Cave2dGame()
{
}

Cave2dGame::Cave2dGame(PakoOpenglApp *parent)
{
  m_parent = parent;
}

/**
 * fXgN^(n)
 */
Cave2dGame::~Cave2dGame()
{
}


/*------------------------------------------------------*/
/* interface                                            */
/*------------------------------------------------------*/

void Cave2dGame::setParent(PakoOpenglApp *parent)
{
  m_parent = parent;
}

int Cave2dGame::initalizeGame(void)
{
  m_nowPlaying = 0;
  m_step = 0;

  for(int i=0; i<(CHAR_WIDTH*CHAR_HEIGHT); i++) {
    m_vram[i] = 0;
  }
  
  /* --- XvCg߂Ɋmۂ */
  m_parent->createSpriteLayer(2, 512, 2);

  /* --- TEh~ */
  SoundMusicStop();
  SoundSEStop();

  return(0);
}

int Cave2dGame::getState(void)
{
  return(m_nowPlaying);
}



/* ----------------------------------------- */
/* --- tick() */
/**
 * t[ĂяoQ[{̃\bh
 * pŃI[o[ChĂɃQ[{̂Lq
 * 1t[̍ƂI烁\bh𔲂邱
 *
 * @return trueŒʏƒAfalseŃQ[I
 *
 */
bool Cave2dGame::tick(void)
{
  PakoSpriteItem *obj;
  int  key;
  int  i;

  /* --- Q[isXebv[N */
  switch(m_step) {
    /* -  */
  case 0:
    /* - XvCg */
    for(i=0; i<64; i++) {
      obj = m_parent->getSpriteItem(1, i);
      obj->m_Visible = false;
    }
    for(i=0; i<512; i++) {
      obj = m_parent->getSpriteItem(2, i);
      obj->m_Visible = false;
    }
    for(i=0; i<(CHAR_WIDTH*CHAR_HEIGHT); i++) {
      m_vram[i] = 0;
    }
    m_step = 1;
    break;
    
    /* - X^[g҂ */
  case 1:
    key = InputJoyKeyTriger(0);
    if ((key & (IN_Button1 | IN_Button2)) != 0) {
      m_step = 2;
      m_wait = 0;
      m_hole_x = 5;
      m_myship_x = 11;
      m_score = 0;
    }
    if ((key & (IN_Button3 | IN_Button4)) != 0) {
      m_step = 4;
      m_nowPlaying = 1;
      m_parent->deleteSpriteLayer(2);
    }
    break;
    
    /* - Q[{ */
  case 2:
    if (cave_game() == false) {
      SoundMusicOneshot(2);
      m_gameover_timer = 5 * 60;
      m_step = 3;
    }
    break;
    
    /* - Q[I[o[EFCg */
  case 3:
    m_gameover_timer -= 1;
    if (m_gameover_timer <= 0) {
      m_step = 0;
    }
    break;

  case 4:
    m_nowPlaying = 1;
    break;

  }

   
  return true;
}


/* ----------------------------------------- */
/* --- tickDisplay() */
/**
 * t[Ăяoʕ\\bh
 * pŃI[o[ChĂɉʕ`揈Lq
 * tick()̒ɋLqĂǂA̓t[XLbv
 * ΂Ă΂Ȃ̂ŏ肭p
 *
 * @return trueŒʏƒAfalseŕ\ُ
 *
 */
bool Cave2dGame::tickDisplay(void)
{
  PakoSpriteItem *obj;
  /* --- cg rom */
  const int cg_rom_x[] = 
    {0, 15, 45, 75, 105, 135, 150, 165, 180, 195,
     15, 30, 45, 60, 75, 90, 105, 120, 135, 150};
  const int cg_rom_y[] = 
    {242, 242, 242, 242, 242, 242, 242, 242, 242, 242,
     308, 308, 308, 308, 308, 308, 308, 308, 308, 308};

  /* --- L[҂̎ */
  if (m_step == 1) {
    obj = m_parent->getSpriteItem(2, 0);
    obj->m_PosX = 240;
    obj->m_PosY = 105;
    obj->m_SizeW = 60;
    obj->m_SizeH = 11;
    obj->m_Blend = 1.0;
    obj->m_TexU = 15;
    obj->m_TexV = 264;
    obj->m_TexW = 60;
    obj->m_TexH = 11;
    obj->m_RollZ = 0;
    obj->m_Zoom = 1.0;
    obj->m_PosCenter = true;
    obj->m_Visible = true;
    obj->m_TextureID = 0;
    obj = m_parent->getSpriteItem(2, 1);
    obj->m_PosX = 240;
    obj->m_PosY = 138;
    obj->m_SizeW = 180;
    obj->m_SizeH = 11;
    obj->m_Blend = 1.0;
    obj->m_TexU = 15;
    obj->m_TexV = 286;
    obj->m_TexW = 180;
    obj->m_TexH = 11;
    obj->m_RollZ = 0;
    obj->m_Zoom = 1.0;
    obj->m_PosCenter = true;
    obj->m_Visible = true;
    obj->m_TextureID = 0;
    return(true);
  }

  /* --- display VRAM */
  for(int i=0; i<(CHAR_WIDTH*CHAR_HEIGHT); i++) {
    obj = m_parent->getSpriteItem(2, i);
    if (m_vram[i] == 0) {
      obj->m_Visible = false;
      continue;
    }
    obj->m_PosX = ((i % 22) * 15) + 75;
    obj->m_PosY = ((i / 22) * 11) + 9;
    obj->m_SizeW = 15;
    obj->m_SizeH = 11;
    obj->m_Blend = 1.0;
    obj->m_TexU = cg_rom_x[m_vram[i]];
    obj->m_TexV = cg_rom_y[m_vram[i]];
    obj->m_TexW = 15;
    obj->m_TexH = 11;
    obj->m_RollZ = 0;
    obj->m_Zoom = 1.0;
    obj->m_PosCenter = false;
    obj->m_Visible = true;
    obj->m_TextureID = 0;
  }

  return true;
}


/*------------------------------------------------------*/
/* private method                                       */
/*------------------------------------------------------*/

/* ----------------------------------------- */
/* --- Q[{ */
bool  Cave2dGame::cave_game(void)
{
  int  i;
  int  pos, key, size;
  bool  result;

  result = true;

  /* --- EGCg */
  if (m_wait > 0) {
    m_wait -= 1;
    return(true);
  }
  /* - ̃EFCg */
  m_wait = 20 - (m_score / 25);
  if (m_wait < 1) {
    m_wait = 1;
  }
  m_score += 1;

  /* --- L */
  pos = CHAR_WIDTH * 4 + m_myship_x;
  m_vram[pos] = 2;

  /* --- 1sXN[ */
  for(i=0; i<CHAR_WIDTH*(CHAR_HEIGHT-1); i++) {
    m_vram[i] = m_vram[i+CHAR_WIDTH];
  }

  /* --- Lړ */
  key = InputJoyKey(0);
  if (((key & IN_Left) != 0) && (m_myship_x > 0)) {
    m_myship_x -= 1;
  }
  if (((key & IN_Right) != 0) && (m_myship_x < (CHAR_WIDTH-1))) {
    m_myship_x += 1;
  }
  
  /* --- Փ˔ */
  pos = CHAR_WIDTH * 4 + m_myship_x;
  if (m_vram[pos] == 1) {
    result = false;
    m_vram[pos] = 4;
  }
  else {
    m_vram[pos] = 3;
  }
  
  /* --- A */
  size = 12 - (m_score / 100);
  if (size < 1) {
    size = 1;
  }
  pos = CHAR_WIDTH * (CHAR_HEIGHT - 1);
  for(i=0; i<CHAR_WIDTH; i++) {
    m_vram[pos+i] = 1;
  }
  m_hole_x += PakoMath::Rand(0, 2) - 1;
  if (m_hole_x < 1) {
    m_hole_x = 1;
  }
  if ((m_hole_x + size) >= 22) {
    m_hole_x = (CHAR_WIDTH - 1) - size - 1;
  }
  pos = CHAR_WIDTH * (CHAR_HEIGHT - 1) + m_hole_x;
  for(i=0; i<size; i++) {
    m_vram[pos+i] = 0;
  }

  display_score();

  return(result);
}


void  Cave2dGame::display_score()
{
  int pos, score, keta, kurai;
  bool display;

  m_vram[0] = 5;
  m_vram[1] = 6;
  m_vram[2] = 7;
  m_vram[3] = 8;
  m_vram[4] = 9;
  m_vram[5] = 0;

  kurai = 100000;
  score = m_score * 10;
  display = false;
  pos = 6;
  for(int i=0; i<6; i++) {
    keta = 0;
    if (score >= kurai) {
      keta = (score / kurai) % 10;
      score = (score % kurai);
      display = true;
    }
    if (display == true) {
      m_vram[pos] = keta + 10;
      pos += 1;
    }
    kurai /= 10;
  }
}

