/* ---------------------------------------------------------- */
/*  tcgs_cave_3d.h                                            */
/* ---------------------------------------------------------- */

/*------------------------------------------------------------- */
/** @file
    @brief    3D cave race
    @author   rerofumi
    @since    Nov.08.2006
*/
/*-----------------------------------------------------
 Copyright (C) 2006 fumi2kick/rerofumi <rero2@yuumu.org>
 All Rights Reserved.
 ------------------------------------------------------*/

#ifndef TCGS_CAVE_3D_H
#define TCGS_CAVE_3D_H

/*-------------------------------*/
/* struct                        */
/*-------------------------------*/
#define MODEL_NUM  20

#define ALLSTAGE  3

typedef struct {
  float x, y;
  float size;
  float hole_w, hole_h;
} CaveModel;


/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include <vector>
#include "pako_opengl_app.h"

/**
 * @brief 3DAQ[
 *
 * @todo -
 * @bug -
 */
class Cave3dGame
{
  /* --- RXgN^EfXgN^ */
 public:
  Cave3dGame();
  Cave3dGame(PakoOpenglApp *parent);
  virtual  ~Cave3dGame();

  /* --- AvP[V\bh */
 public:
  void setParent(PakoOpenglApp *parent);
  int initalizeGame(void);
  int initializeStage(int stage);
  int getState(void);
  bool tick(void);
  bool tickDisplay(void);

  /* --- [J[N */
 private:
  //! ĂяoeNX
  PakoOpenglApp *m_parent;
  //! S̃NbN
  int  m_clock;
  //! Q[̐is
  int  m_nowPlaying;
  //! Q[Ŝ̐isXebv
  int  m_gameStep;
  //! Q[Xe[W
  int  m_gameStage;
  //! vC[̈ʒu
  float  m_playerX, m_playerY;
  //! vC[̈ړx
  float  m_playerMoveX, m_playerMoveY;
  //! vC[̃[
  float  m_playerRoll, m_playerMoveRoll;
  //! vC[̐isx
  float  m_playerSpeed;
  //! vC[̐isʒu
  float  m_playerForword;
  //! Xe[W̐Fݒ
  float  m_stageColor[4];
  //! vC[SHIELD_[W
  float  m_playerShield;
  //! X^[gOf
  int  m_beforeStart;
  //! NÃf^C}[
  int  m_afterClear;
  //!  Q[I[o[̃f^C}[
  int  m_gameoverTimer;
  //! xXgbvL^
  int  m_record[ALLSTAGE];
  //! vC[̋L^
  int  m_result[ALLSTAGE];

  /* --- Q[p */
 public:
  float m_playerPosition;

  //! A\pz
  CaveModel  *model[MODEL_NUM];
  //! Xe[Wf[^p
  vector<CaveModel>  stage_data;
  //! i񂾋
  int  m_forword;
  //! Xe[Wbv^C
  int  m_stageTime;
  //! Xe[WBGMԍ
  int  m_stageMusic;

 protected:
  void gl_disp_frame(float size, float hole_w, float hole_h);
  int forword_step(void);
  void myship_move(void);
  void sprite_disp(void);
  void time_disp(int x, int y, int frame, int sp);
  void sprite_goal_disp(int timer);
  void sprite_retire_disp(void);
  void sprite_allclear_disp(int timer);

  void load_record_time(void);
  void save_record_time(void);
};

#endif
